Option Strict Off
Imports System.Windows.Forms
Imports System.IO

Public Class MDIParent1

    'Dieser Source-Code kann frei verwendet werden!
    'fr evtl. auftretende Schden wird nicht gehaftet

    'dieses Beispiel soll zeigen wie sich mit Hilfe von ToolStripButtons durch geffnete Dokumente navigieren lsst
    'und bietet gengend Mglichkeiten noch zur Erweiterung und Vervollstndigung!

    Public m_ChildFormNumber As Integer

    Public Sub ToolStripDocButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Try
            'Steuert die Aktivierung des gewnschten Dokuments
            Dim oToolDocButton As ToolStripButton = sender

            If Me.MdiChildren.Length = 0 Then
                MsgBox("Es sind keine Dokumente geffnet!", MsgBoxStyle.Exclamation)
                Exit Sub
            End If
            Dim frm As New Form1
            Dim sFileName As String = oToolDocButton.Tag

            'die geffneten Child-Fenster durchlaufen
            For Each frm In Me.MdiChildren
                'auf eine bereinstimmung hin berprfen
                If frm.Text = sFileName Then
                    'und entsprechend aktivieren
                    frm.Activate()
                    Exit For
                End If
            Next

        Catch ex As Exception
            Cursor = Cursors.Default
            MsgBox(ex.Message, MsgBoxStyle.Exclamation, "Fehler")
        End Try
    End Sub

    Private Sub ShowNewForm(ByVal sender As Object, ByVal e As EventArgs) Handles NewToolStripMenuItem.Click, NewToolStripButton.Click, NewWindowToolStripMenuItem.Click
        Dim frm As New Form1
        m_ChildFormNumber += 1
        With frm
            .Text = "Dokument" & " " & m_ChildFormNumber
            .Tag = "Dokument" & " " & m_ChildFormNumber
            .MdiParent = Me
            .Show()
        End With
    End Sub

    Private Sub OpenFile(ByVal sender As Object, ByVal e As EventArgs) Handles OpenToolStripMenuItem.Click, OpenToolStripButton.Click
        Dim dlgOpen As New OpenFileDialog
        With dlgOpen
            If .ShowDialog(Me) = Windows.Forms.DialogResult.OK Then

                'prfen ob Datei bereits geffnet ist
                Dim bgeffnet As Boolean
                bgeffnet = False

                Dim NewFrm As Form1
                For Each NewFrm In Me.MdiChildren
                    If NewFrm.Tag = .FileName Then
                        bgeffnet = True
                        NewFrm.Activate()
                        Exit For
                    End If
                Next

                If bgeffnet = True Then
                    .Dispose()
                    Exit Sub
                Else    'wenn noch nicht geffnet
                    Dim frm As New Form1
                    Dim FileExtension As String = StrConv(Mid(dlgOpen.FileName, InStrRev(dlgOpen.FileName, ".")), VbStrConv.Lowercase)
                    If FileExtension = ".rtf" Then
                        frm.txtContents.LoadFile(dlgOpen.FileName, RichTextBoxStreamType.RichText)
                    ElseIf FileExtension = ".txt" Then
                        frm.txtContents.LoadFile(dlgOpen.FileName, RichTextBoxStreamType.PlainText)
                    Else
                        frm.txtContents.Text = File.ReadAllText(dlgOpen.FileName)
                    End If

                    m_ChildFormNumber += 1

                    frm.txtContents.Select(0, 0)
                    frm.Text = New FileInfo(dlgOpen.FileName).Name
                    frm.Tag = .FileName
                    frm.MdiParent = Me
                    frm.Show()
                End If

            End If
        End With
    End Sub

    Private Sub SaveAsToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles SaveAsToolStripMenuItem.Click
        'Dim SaveFileDialog As New SaveFileDialog
        'SaveFileDialog.InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
        'SaveFileDialog.Filter = "Text Files (*.txt)|*.txt"
        'SaveFileDialog.ShowDialog(Me)

        'Dim FileName As String = SaveFileDialog.FileName
        '' TODO: Add code here to save the current contents of the form to a file.
    End Sub

    Private Sub ExitToolsStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ExitToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub CutToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CutToolStripMenuItem.Click
        Try
            If Not IsNothing(Me.ActiveMdiChild) Then
                Dim myDoc As Form1 = Me.ActiveMdiChild
                With myDoc.txtContents
                    .Cut()
                End With
            End If

        Catch ex As Exception

        End Try
    End Sub

    Private Sub CopyToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CopyToolStripMenuItem.Click
        Try
            If Not IsNothing(Me.ActiveMdiChild) Then
                Dim myDoc As Form1 = Me.ActiveMdiChild
                With myDoc.txtContents
                    .Copy()
                End With
            End If

        Catch ex As Exception

        End Try
    End Sub

    Private Sub PasteToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles PasteToolStripMenuItem.Click
        Try
            If Not IsNothing(Me.ActiveMdiChild) Then
                Dim myDoc As Form1 = Me.ActiveMdiChild
                With myDoc.txtContents
                    .Paste()
                End With
            End If

        Catch ex As Exception

        End Try
    End Sub

    Private Sub ToolBarToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ToolBarToolStripMenuItem.Click
        Me.ToolStrip.Visible = Me.ToolBarToolStripMenuItem.Checked
    End Sub

    Private Sub StatusBarToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles StatusBarToolStripMenuItem.Click
        Me.StatusStrip.Visible = Me.StatusBarToolStripMenuItem.Checked
    End Sub

    Private Sub CascadeToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CascadeToolStripMenuItem.Click
        Me.LayoutMdi(MdiLayout.Cascade)
    End Sub

    Private Sub TileVerticleToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles TileVerticalToolStripMenuItem.Click
        Me.LayoutMdi(MdiLayout.TileVertical)
    End Sub

    Private Sub TileHorizontalToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles TileHorizontalToolStripMenuItem.Click
        Me.LayoutMdi(MdiLayout.TileHorizontal)
    End Sub

    Private Sub ArrangeIconsToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ArrangeIconsToolStripMenuItem.Click
        Me.LayoutMdi(MdiLayout.ArrangeIcons)
    End Sub

    Private Sub MinimizeAllToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MinimizeAllToolStripMenuItem.Click
        For Each frm As Form In Me.MdiChildren
            frm.WindowState = FormWindowState.Minimized
        Next frm
    End Sub

    Private Sub RestoreAllToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RestoreAllToolStripMenuItem.Click
        For Each frm As Form In Me.MdiChildren
            frm.WindowState = FormWindowState.Normal
        Next frm
    End Sub

    Private Sub MaximizeAllToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MaximizeAllToolStripMenuItem.Click
        For Each frm As Form In Me.MdiChildren
            frm.WindowState = FormWindowState.Maximized
        Next frm
    End Sub

    Private Sub CloseAllToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CloseAllToolStripMenuItem.Click
        For Each frm As Form In Me.MdiChildren
            frm.Close()
        Next
    End Sub

    'hab leider keine Ahnung mehr, von wem dieser Source-Code stammt (Sorry)!
    ' Anzeigen der Window-Icons in der Fensterliste
    Private Sub WindowsMenu_DropDownOpening( _
      ByVal sender As Object, _
      ByVal e As System.EventArgs) _
      Handles WindowsMenu.DropDownOpening

        ' WindowsMenu ist das MenuItem, welches die MDI-Liste anzeigt
        For Each menuItem As ToolStripItem In WindowsMenu.DropDownItems
            If (TypeOf menuItem Is ToolStripMenuItem) AndAlso _
              (DirectCast(menuItem, ToolStripMenuItem).IsMdiWindowListEntry) Then

                menuItem.Image = TryCast(menuItem.[GetType]().GetProperty("MdiForm", _
                  Reflection.BindingFlags.GetProperty Or _
                  Reflection.BindingFlags.IgnoreCase Or _
                  Reflection.BindingFlags.Instance Or _
                  Reflection.BindingFlags.NonPublic) _
                 .GetValue(menuItem, Nothing), Form).Icon.ToBitmap()

                menuItem.ImageTransparentColor = Color.Aquamarine
            End If
        Next
    End Sub

    Private Sub UndoToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UndoToolStripMenuItem.Click
        Try
            If Not IsNothing(Me.ActiveMdiChild) Then
                Dim myDoc As Form1 = Me.ActiveMdiChild
                With myDoc.txtContents
                    .Undo()
                End With
            End If

        Catch ex As Exception

        End Try
    End Sub

    Private Sub RedoToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RedoToolStripMenuItem.Click
        Try
            If Not IsNothing(Me.ActiveMdiChild) Then
                Dim myDoc As Form1 = Me.ActiveMdiChild
                With myDoc.txtContents
                    .Redo()
                End With
            End If

        Catch ex As Exception

        End Try
    End Sub

    Private Sub SelectAllToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SelectAllToolStripMenuItem.Click
        Try
            If Not IsNothing(Me.ActiveMdiChild) Then
                Dim myDoc As Form1 = Me.ActiveMdiChild
                With myDoc.txtContents
                    .SelectAll()
                End With
            End If

        Catch ex As Exception

        End Try
    End Sub

End Class
